// mfc_dlgDlg.cpp : implementation file
//

#include "stdafx.h"
#include "mfc_dlg.h"
#include "mfc_dlgDlg.h"
#include ".\mfc_dlgdlg.h"
#include <windows.h>
#include "ftd2xx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// Cmfc_dlgDlg dialog



Cmfc_dlgDlg::Cmfc_dlgDlg(CWnd* pParent /*=NULL*/)
	: CDialog(Cmfc_dlgDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void Cmfc_dlgDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_DEVLIST, m_devlist);
	DDX_Control(pDX, IDC_OUTPUT0, m_output0);
	DDX_Control(pDX, IDC_OUTPUT1, m_output1);
	DDX_Control(pDX, IDC_OUTPUT2, m_output2);
	DDX_Control(pDX, IDC_OUTPUT3, m_output3);
	DDX_Control(pDX, IDC_HIGH0, m_high0);
	DDX_Control(pDX, IDC_HIGH1, m_high1);
	DDX_Control(pDX, IDC_HIGH2, m_high2);
	DDX_Control(pDX, IDC_HIGH3, m_high3);
	DDX_Control(pDX, IDC_LOW0, m_low0);
	DDX_Control(pDX, IDC_LOW1, m_low1);
	DDX_Control(pDX, IDC_LOW2, m_low2);
	DDX_Control(pDX, IDC_LOW3, m_low3);
}

BEGIN_MESSAGE_MAP(Cmfc_dlgDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDCANCEL, OnBnClickedCancel)
	ON_CBN_DROPDOWN(IDC_DEVLIST, OnCbnDropdownDevlist)
	ON_BN_CLICKED(ID_SETBITS, OnBnClickedSetbits)
	ON_BN_CLICKED(ID_READBITS, OnBnClickedReadbits)
END_MESSAGE_MAP()


// Cmfc_dlgDlg message handlers

BOOL Cmfc_dlgDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	
	ftHandle = NULL;
	m_output0.SetCheck (BST_UNCHECKED);
	m_output1.SetCheck (BST_UNCHECKED);
	m_output2.SetCheck (BST_UNCHECKED);
	m_output3.SetCheck (BST_UNCHECKED);
	m_high0.SetCheck (BST_CHECKED);
	m_high1.SetCheck (BST_CHECKED);
	m_high2.SetCheck (BST_CHECKED);
	m_high3.SetCheck (BST_CHECKED);
	m_low0.SetCheck (BST_UNCHECKED);
	m_low1.SetCheck (BST_UNCHECKED);
	m_low2.SetCheck (BST_UNCHECKED);
	m_low3.SetCheck (BST_UNCHECKED);

	MessageBox("This example requires that the FT232R \n EEPROM be set for CBUS Bit Bang mode.", "Attention", MB_OK);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void Cmfc_dlgDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void Cmfc_dlgDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR Cmfc_dlgDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void Cmfc_dlgDlg::OnBnClickedCancel()
{
	// TODO: Add your control notification handler code here
	OnCancel();
}


void Cmfc_dlgDlg::OnCbnDropdownDevlist()
{
	FT_STATUS ftStatus;
	DWORD NumDevs;
	DWORD RCount;
	DWORD count;

	FT_DEVICE_LIST_INFO_NODE *DevInfo;
	FT_DEVICE_LIST_INFO_NODE *RDevsInfo;


	m_devlist.ResetContent();
	// Get number of devices connected
	ftStatus = FT_CreateDeviceInfoList(&NumDevs);
	// Allocate storage
	DevInfo = (FT_DEVICE_LIST_INFO_NODE*)malloc(sizeof(FT_DEVICE_LIST_INFO_NODE)*NumDevs);
	// Get device list
	ftStatus = FT_GetDeviceInfoList(DevInfo,&NumDevs);
	// Get number of FT232R devices
	RCount = 0;
	for (count = 0; count < NumDevs; count++ ) {
		if (DevInfo[count].Type == 5) {
			RCount = RCount + 1;
			};
		}
	// Ensure at least 1 R chip available.  If not, show dialog
	if (RCount == 0) {
		MessageBox("No FT232R or FT245R devices found.", "Error", MB_OK);
	}
	else {
		// Allocate storage for R chips
		RDevsInfo = (FT_DEVICE_LIST_INFO_NODE*)malloc(sizeof(FT_DEVICE_LIST_INFO_NODE)*RCount);
		// Get R chip device list
		RCount = 0;
		for (count = 0; count < NumDevs; count++ ) {
			if (DevInfo[count].Type = 6) {
				RDevsInfo[RCount] = DevInfo[count];
				RCount = RCount + 1;
				};
			}
		// Populate combobox
		for (count = 0; count < NumDevs; count++ ) {
			m_devlist.AddString(DevInfo[count].Description);
			}
		// Free storage
		free(DevInfo);	
		free(RDevsInfo);
	}
}


void Cmfc_dlgDlg::OnBnClickedSetbits()
{
	char * PChar;
	FT_STATUS ftStatus;
	byte ucMask;

	PChar = (char*)malloc(m_devlist.GetLBTextLen(m_devlist.GetCurSel())+1);
	if (PChar != NULL) {
		m_devlist.GetLBText(m_devlist.GetCurSel(),PChar);
		// Open device
		ftStatus = FT_OpenEx(PChar,FT_OPEN_BY_DESCRIPTION,&ftHandle);
		free(PChar);
	}

	// Initialise mask value
	ucMask =0x0;
	// Find mask value to write
	if (m_output0.GetCheck() == BST_CHECKED) {
		if (m_high0.GetCheck() == BST_CHECKED) {
			ucMask = (ucMask | 0x11);
			}
		else {
			ucMask = (ucMask | 0x10);
			}
		}
	if (m_output1.GetCheck() == BST_CHECKED) {
		if (m_high1.GetCheck() == BST_CHECKED) {
			ucMask = (ucMask | 0x22);
			}
		else {
			ucMask = (ucMask | 0x20);
			}
		}
	if (m_output2.GetCheck() == BST_CHECKED) {
		if (m_high2.GetCheck() == BST_CHECKED) {
			ucMask = (ucMask | 0x44);
			}
		else {
			ucMask = (ucMask | 0x40);
			}
		}
	if (m_output3.GetCheck() == BST_CHECKED) {
		if (m_high3.GetCheck() == BST_CHECKED) {
			ucMask = (ucMask | 0x88);
			}
		else {
			ucMask = (ucMask | 0x80);
			}
		}


	// Set CBUS pins states
	ftStatus = FT_SetBitMode(ftHandle,ucMask,0x20);

	// Check to see if write successful
	if (ftStatus != 0) {
		MessageBox("Failed to write data to CBUS pins.", "Error", MB_OK);
	}

	// Close device handle
	ftStatus = FT_Close(ftHandle);

}



void Cmfc_dlgDlg::OnBnClickedReadbits()
{
	char * PChar;
	FT_STATUS ftStatus;
	byte ucMask;

	PChar = (char*)malloc(m_devlist.GetLBTextLen(m_devlist.GetCurSel())+1);
	if (PChar != NULL) {
		m_devlist.GetLBText(m_devlist.GetCurSel(),PChar);
		// Open device
		ftStatus = FT_OpenEx(PChar,FT_OPEN_BY_DESCRIPTION,&ftHandle);
		free(PChar);
	}

	// Get CBUS pins states
	ftStatus = FT_GetBitMode(ftHandle,&ucMask);

	// Check to see if read successful
	if (ftStatus != 0) {
		MessageBox("Failed to read data from CBUS pins.", "Error", MB_OK);
	}

	// Mask off bits to find which pins are high and which are low
	if (ucMask & 0x01) {
		// bit 0 is high
		m_high0.SetCheck(BST_CHECKED);
		m_low0.SetCheck(BST_UNCHECKED);
	}
	else {
		// bit 0 is low
		m_high0.SetCheck(BST_UNCHECKED);
		m_low0.SetCheck(BST_CHECKED);
	}
	if (ucMask & 0x02) {
		// bit 1 is high
		m_high1.SetCheck(BST_CHECKED);
		m_low1.SetCheck(BST_UNCHECKED);
	}
	else {
		// bit 1 is low
		m_high1.SetCheck(BST_UNCHECKED);
		m_low1.SetCheck(BST_CHECKED);
	}
	if (ucMask & 0x04) {
		// bit 2 is high
		m_high2.SetCheck(BST_CHECKED);
		m_low2.SetCheck(BST_UNCHECKED);
	}
	else {
		// bit 2 is low
		m_high2.SetCheck(BST_UNCHECKED);
		m_low2.SetCheck(BST_CHECKED);
	}
	if (ucMask & 0x08) {
		// bit 3 is high
		m_high3.SetCheck(BST_CHECKED);
		m_low3.SetCheck(BST_UNCHECKED);
	}
	else {
		// bit 3 is low
		m_high3.SetCheck(BST_UNCHECKED);
		m_low3.SetCheck(BST_CHECKED);
	}


	// Close device handle
	ftStatus = FT_Close(ftHandle);

}

